unit Watches;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, SBasic, canvas;

type
  TWatchForm = class(TForm)
    Panel1: TPanel;
    FuncPanel: TPanel;
    VarPanel: TPanel;
    ConstPanel: TPanel;

    FuncListBox: TListBox;
    VarListBox: TListBox;
    ConstListBox: TListBox;
    CodeListBox: TListBox;

    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label4: TLabel;
    Panel4: TPanel;

    ResetButton: TButton;
    StepButton: TButton;
    CloseButton: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ResetButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StepButtonClick(Sender: TObject);
  private
  public
    SpeedButton2 : TSpeedButton;
    SBasic1      : TSBasic;
    IP           : integer;
    flag_exit    : boolean;
  end;

var
  WatchForm: TWatchForm;

implementation

{$R *.DFM}

procedure TWatchForm.FormCreate(Sender: TObject);
begin
     IP := -1;
     flag_exit := false;
end;

procedure TWatchForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     SpeedButton2.Down := false;
end;

procedure TWatchForm.ResetButtonClick(Sender: TObject);
begin
     IP := -1;
     flag_exit := false;
     SBasic1.Reset_all;
     SBasic1.Fill_Watches;
end;

procedure TWatchForm.CloseButtonClick(Sender: TObject);
begin
     Close;
end;

procedure TWatchForm.StepButtonClick(Sender: TObject);
begin

     if Ip >= SBasic1.Code_Count then Ip := -1;
     if Ip = -1 then
     begin
          if SBasic1.Translate = 0 then
          begin
               if not CanvasForm.SpeedButton1.Down then
               begin
                    CanvasForm.Show;
                    CanvasForm.repaint;
                    CanvasForm.SpeedButton1.Down := true;
                    update;
               end;
               SBasic1.Set_value( 'MAX_X', 0, CanvasForm.MAX_X-1 );
               SBasic1.Set_value( 'MAX_Y', 0, CanvasForm.MAX_Y-1 );
               SBasic1.Fill_Watches;
               Ip := 0;
          end;
     end
     else begin
          SBasic1.Run_step( Ip, flag_exit );
     end;
     SBasic1.Fill_VarList;
     SBasic1.Fill_ConstList;
     CodeListBox.ItemIndex := IP;
end;

end.
